#!/usr/bin/env python
# -*- coding: utf-8 -*-

#charger les bibliothèques en particulier re pour les expression régulière
import sys, os, re , simplejson, errno

# ouvre le fichier et lit les lignes lève une exception si le fichier à parser est absent
try:
	fichier = open("fichier_a_analyser.txt", "r")
	lignes = fichier.readlines()
	fichier.close()
	
	# créer les fichiers pour stocker les résultats
	resultat_spam = open("resultat_spam.txt", "w+")
	resultat_ham = open("resultat_ham.txt", "w+")

	# on accède au dictionnaire des mots tabous JSON: 
	fichier_mots_tabous = open('mots_tabous.json')
	proba_mots_tabous = simplejson.load(fichier_mots_tabous)
	fichier_mots_tabous.close()
	
	# créer la liste des mots tabous à partir des clés du dictionnaire
	mots_tabous = proba_mots_tabous.keys()

	# constantes à adapter
	proba_spam = 0.1
	seuil_tolerance = 2

	for ligne in lignes:
		score = 0
		motpresent =""
		for mot in mots_tabous:
			#radical du mot + n'importe quoi ensuite
			motregex=mot+'_?' 
			
			#rechercher le radical sans tenir compte de la casse
			if re.search(motregex,ligne,re.IGNORECASE) : 
				# calcul du score spam pour chaque mot trouvé
				score_mot = (proba_mots_tabous[mot][0]*proba_spam)/(proba_mots_tabous[mot][0]*proba_spam+proba_mots_tabous[mot][1]*(1-proba_spam))
				score=score+score_mot*proba_mots_tabous[mot][2]
				motpresent = motpresent+" "+mot

		if (score>seuil_tolerance):
			print ligne
			resultat_spam.write(" "+str(score) + " ***" + motpresent +"***\n"+ligne)
		else :
			resultat_ham.write(ligne)

	print "**** Le texte a été analysé et les résultats sauvegardés dans resultat_spam.txt et resultat_ham.txt ****"

	resultat_ham.close()
	resultat_spam.close()
except IOError, e:
        print e
        print "Vérifiez que le fichier fichier_a_analyser.txt est bien présent."
    



